Index: uspace/drv/ns8250/ns8250.c
===================================================================
--- uspace/drv/ns8250/ns8250.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/drv/ns8250/ns8250.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -55,5 +55,4 @@
 #include <ddf/driver.h>
 #include <ddf/interrupt.h>
-#include <ddf/log.h>
 #include <ops/char_dev.h>
 
@@ -276,11 +275,11 @@
 static bool ns8250_pio_enable(ns8250_t *ns)
 {
-	ddf_msg(LVL_DEBUG, "ns8250_pio_enable %s", ns->dev->name);
+	printf(NAME ": ns8250_pio_enable %s\n", ns->dev->name);
 	
 	/* Gain control over port's registers. */
 	if (pio_enable((void *)(uintptr_t) ns->io_addr, REG_COUNT,
 	    (void **) &ns->port)) {
-		ddf_msg(LVL_ERROR, "Cannot map the port %#" PRIx32
-		    " for device %s.", ns->io_addr, ns->dev->name);
+		printf(NAME ": error - cannot gain the port %#" PRIx32 " for device "
+		    "%s.\n", ns->io_addr, ns->dev->name);
 		return false;
 	}
@@ -296,5 +295,5 @@
 static bool ns8250_dev_probe(ns8250_t *ns)
 {
-	ddf_msg(LVL_DEBUG, "ns8250_dev_probe %s", ns->dev->name);
+	printf(NAME ": ns8250_dev_probe %s\n", ns->dev->name);
 	
 	ioport8_t *port_addr = ns->port;
@@ -314,8 +313,6 @@
 	pio_write_8(port_addr + 4, olddata);
 	
-	if (!res) {
-		ddf_msg(LVL_DEBUG, "Device %s is not present.",
-		    ns->dev->name);
-	}
+	if (!res)
+		printf(NAME ": device %s is not present.\n", ns->dev->name);
 	
 	return res;
@@ -329,5 +326,5 @@
 static int ns8250_dev_initialize(ns8250_t *ns)
 {
-	ddf_msg(LVL_DEBUG, "ns8250_dev_initialize %s", ns->dev->name);
+	printf(NAME ": ns8250_dev_initialize %s\n", ns->dev->name);
 	
 	int ret = EOK;
@@ -340,6 +337,6 @@
 	    IPC_FLAG_BLOCKING);
 	if (ns->dev->parent_phone < 0) {
-		ddf_msg(LVL_ERROR, "Failed to connect to parent driver of "
-		    "device %s.", ns->dev->name);
+		printf(NAME ": failed to connect to the parent driver of the "
+		    "device %s.\n", ns->dev->name);
 		ret = ns->dev->parent_phone;
 		goto failed;
@@ -349,6 +346,6 @@
 	ret = hw_res_get_resource_list(ns->dev->parent_phone, &hw_resources);
 	if (ret != EOK) {
-		ddf_msg(LVL_ERROR, "Failed to get HW resources for device "
-		    "%s.", ns->dev->name);
+		printf(NAME ": failed to get hw resources for the device "
+		    "%s.\n", ns->dev->name);
 		goto failed;
 	}
@@ -365,5 +362,5 @@
 			ns->irq = res->res.interrupt.irq;
 			irq = true;
-			ddf_msg(LVL_NOTE, "Device %s was asigned irq = 0x%x.",
+			printf(NAME ": the %s device was asigned irq = 0x%x.\n",
 			    ns->dev->name, ns->irq);
 			break;
@@ -372,13 +369,13 @@
 			ns->io_addr = res->res.io_range.address;
 			if (res->res.io_range.size < REG_COUNT) {
-				ddf_msg(LVL_ERROR, "I/O range assigned to "
-				    "device %s is too small.", ns->dev->name);
+				printf(NAME ": i/o range assigned to the device "
+				    "%s is too small.\n", ns->dev->name);
 				ret = ELIMIT;
 				goto failed;
 			}
 			ioport = true;
-			ddf_msg(LVL_NOTE, "Device %s was asigned I/O address = "
-			    "0x%x.", ns->dev->name, ns->io_addr);
-    			break;
+			printf(NAME ": the %s device was asigned i/o address = "
+			    "0x%x.\n", ns->dev->name, ns->io_addr);
+			break;
 			
 		default:
@@ -388,5 +385,5 @@
 	
 	if (!irq || !ioport) {
-		ddf_msg(LVL_ERROR, "Missing HW resource(s) for device %s.",
+		printf(NAME ": missing hw resource(s) for the device %s.\n",
 		    ns->dev->name);
 		ret = ENOENT;
@@ -473,6 +470,6 @@
 	
 	if (baud_rate < 50 || MAX_BAUD_RATE % baud_rate != 0) {
-		ddf_msg(LVL_ERROR, "Invalid baud rate %d requested.",
-		    baud_rate);
+		printf(NAME ": error - somebody tried to set invalid baud rate "
+		    "%d\n", baud_rate);
 		return EINVAL;
 	}
@@ -657,9 +654,9 @@
 			if (ns->client_connected) {
 				if (!buf_push_back(&ns->input_buffer, val)) {
-					ddf_msg(LVL_WARN, "Buffer overflow on "
-					    "%s.", ns->dev->name);
+					printf(NAME ": buffer overflow on "
+					    "%s.\n", ns->dev->name);
 				} else {
-					ddf_msg(LVL_DEBUG2, "Character %c saved "
-					    "to the buffer of %s.",
+					printf(NAME ": the character %c saved "
+					    "to the buffer of %s.\n",
 					    val, ns->dev->name);
 				}
@@ -717,5 +714,5 @@
 	int rc;
 	
-	ddf_msg(LVL_DEBUG, "ns8250_add_device %s (handle = %d)",
+	printf(NAME ": ns8250_add_device %s (handle = %d)\n",
 	    dev->name, (int) dev->handle);
 	
@@ -752,5 +749,5 @@
 	/* Register interrupt handler. */
 	if (ns8250_register_interrupt_handler(ns) != EOK) {
-		ddf_msg(LVL_ERROR, "Failed to register interrupt handler.");
+		printf(NAME ": failed to register interrupt handler.\n");
 		rc = EADDRNOTAVAIL;
 		goto fail;
@@ -760,6 +757,6 @@
 	rc = ns8250_interrupt_enable(ns);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed to enable the interrupt. Error code = "
-		    "%d.", rc);
+		printf(NAME ": failed to enable the interrupt. Error code = "
+		    "%d.\n", rc);
 		goto fail;
 	}
@@ -767,5 +764,5 @@
 	fun = ddf_fun_create(dev, fun_exposed, "a");
 	if (fun == NULL) {
-		ddf_msg(LVL_ERROR, "Failed creating function.");
+		printf(NAME ": error creating function.\n");
 		goto fail;
 	}
@@ -775,5 +772,5 @@
 	rc = ddf_fun_bind(fun);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed binding function.");
+		printf(NAME ": error binding function.\n");
 		goto fail;
 	}
@@ -783,5 +780,5 @@
 	ddf_fun_add_to_class(fun, "serial");
 	
-	ddf_msg(LVL_NOTE, "Device %s successfully initialized.",
+	printf(NAME ": the %s device has been successfully initialized.\n",
 	    dev->name);
 	
@@ -865,6 +862,6 @@
 	fibril_mutex_unlock(&data->mutex);
 	
-	ddf_msg(LVL_DEBUG, "ns8250_get_props: baud rate %d, parity 0x%x, word "
-	    "length %d, stop bits %d", *baud_rate, *parity, *word_length,
+	printf(NAME ": ns8250_get_props: baud rate %d, parity 0x%x, word "
+	    "length %d, stop bits %d\n", *baud_rate, *parity, *word_length,
 	    *stop_bits);
 }
@@ -882,6 +879,6 @@
     unsigned int parity, unsigned int word_length, unsigned int stop_bits)
 {
-	ddf_msg(LVL_DEBUG, "ns8250_set_props: baud rate %d, parity 0x%x, word "
-	    "length %d, stop bits %d", baud_rate, parity, word_length,
+	printf(NAME ": ns8250_set_props: baud rate %d, parity 0x%x, word "
+	    "length %d, stop bits %d\n", baud_rate, parity, word_length,
 	    stop_bits);
 	
@@ -943,6 +940,4 @@
 static void ns8250_init(void)
 {
-	ddf_log_init(NAME, LVL_ERROR);
-	
 	ns8250_dev_ops.open = &ns8250_open;
 	ns8250_dev_ops.close = &ns8250_close;
Index: uspace/drv/pciintel/pci.c
===================================================================
--- uspace/drv/pciintel/pci.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/drv/pciintel/pci.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -48,5 +48,4 @@
 
 #include <ddf/driver.h>
-#include <ddf/log.h>
 #include <devman.h>
 #include <ipc/devman.h>
@@ -226,5 +225,5 @@
 
 	if (match_id_str == NULL) {
-		ddf_msg(LVL_ERROR, "Out of memory creating match ID.");
+		printf(NAME ": out of memory creating match ID.\n");
 		return;
 	}
@@ -232,5 +231,5 @@
 	rc = ddf_fun_add_match_id(fun->fnode, match_id_str, 90);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed adding match ID: %s",
+		printf(NAME ": error adding match ID: %s\n",
 		    str_error(rc));
 	}
@@ -324,7 +323,7 @@
 	
 	if (range_addr != 0) {
-		ddf_msg(LVL_DEBUG, "Function %s : address = %" PRIx64
-		    ", size = %x", fun->fnode->name, range_addr,
-		    (unsigned int) range_size);
+		printf(NAME ": function %s : ", fun->fnode->name);
+		printf("address = %" PRIx64, range_addr);
+		printf(", size = %x\n", (unsigned int) range_size);
 	}
 	
@@ -351,5 +350,5 @@
 	hw_res_list->count++;
 	
-	ddf_msg(LVL_NOTE, "Function %s uses irq %x.", fun->fnode->name, irq);
+	printf(NAME ": function %s uses irq %x.\n", fun->fnode->name, irq);
 }
 
@@ -407,5 +406,5 @@
 			char *fun_name = pci_fun_create_name(fun);
 			if (fun_name == NULL) {
-				ddf_msg(LVL_ERROR, "Out of memory.");
+				printf(NAME ": out of memory.\n");
 				return;
 			}
@@ -413,5 +412,5 @@
 			fnode = ddf_fun_create(bus->dnode, fun_inner, fun_name);
 			if (fnode == NULL) {
-				ddf_msg(LVL_ERROR, "Failed creating function.");
+				printf(NAME ": error creating function.\n");
 				return;
 			}
@@ -427,5 +426,5 @@
 			fnode->driver_data = fun;
 			
-			ddf_msg(LVL_DEBUG, "Adding new function %s.",
+			printf(NAME ": adding new function %s.\n",
 			    fnode->name);
 			
@@ -444,7 +443,6 @@
 				child_bus = pci_conf_read_8(fun,
 				    PCI_BRIDGE_SEC_BUS_NUM);
-				ddf_msg(LVL_DEBUG, "Device is pci-to-pci "
-				    "bridge, secondary bus number = %d.",
-				    bus_num);
+				printf(NAME ": device is pci-to-pci bridge, "
+				    "secondary bus number = %d.\n", bus_num);
 				if (child_bus > bus_num)
 					pci_bus_scan(bus, child_bus);
@@ -468,10 +466,10 @@
 	int rc;
 	
-	ddf_msg(LVL_DEBUG, "pci_add_device");
+	printf(NAME ": pci_add_device\n");
 	dnode->parent_phone = -1;
 	
 	bus = pci_bus_new();
 	if (bus == NULL) {
-		ddf_msg(LVL_ERROR, "pci_add_device allocation failed.");
+		printf(NAME ": pci_add_device allocation failed.\n");
 		rc = ENOMEM;
 		goto fail;
@@ -483,6 +481,6 @@
 	    IPC_FLAG_BLOCKING);
 	if (dnode->parent_phone < 0) {
-		ddf_msg(LVL_ERROR, "pci_add_device failed to connect to the "
-		    "parent's driver.");
+		printf(NAME ": pci_add_device failed to connect to the "
+		    "parent's driver.\n");
 		rc = dnode->parent_phone;
 		goto fail;
@@ -493,11 +491,11 @@
 	rc = hw_res_get_resource_list(dnode->parent_phone, &hw_resources);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "pci_add_device failed to get hw resources "
-		    "for the device.");
+		printf(NAME ": pci_add_device failed to get hw resources for "
+		    "the device.\n");
 		goto fail;
 	}
 	got_res = true;
 	
-	ddf_msg(LVL_DEBUG, "conf_addr = %" PRIx64 ".",
+	printf(NAME ": conf_addr = %" PRIx64 ".\n",
 	    hw_resources.resources[0].res.io_range.address);
 	
@@ -511,5 +509,5 @@
 	if (pio_enable((void *)(uintptr_t)bus->conf_io_addr, 8,
 	    &bus->conf_addr_port)) {
-		ddf_msg(LVL_ERROR, "Failed to enable configuration ports.");
+		printf(NAME ": failed to enable configuration ports.\n");
 		rc = EADDRNOTAVAIL;
 		goto fail;
@@ -518,9 +516,9 @@
 	
 	/* Make the bus device more visible. It has no use yet. */
-	ddf_msg(LVL_DEBUG, "Adding a 'ctl' function");
+	printf(NAME ": adding a 'ctl' function\n");
 	
 	ctl = ddf_fun_create(bus->dnode, fun_exposed, "ctl");
 	if (ctl == NULL) {
-		ddf_msg(LVL_ERROR, "Failed creating control function.");
+		printf(NAME ": error creating control function.\n");
 		rc = ENOMEM;
 		goto fail;
@@ -529,10 +527,10 @@
 	rc = ddf_fun_bind(ctl);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed binding control function.");
+		printf(NAME ": error binding control function.\n");
 		goto fail;
 	}
 	
 	/* Enumerate functions. */
-	ddf_msg(LVL_DEBUG, "Scanning the bus");
+	printf(NAME ": scanning the bus\n");
 	pci_bus_scan(bus, 0);
 	
@@ -556,5 +554,4 @@
 static void pciintel_init(void)
 {
-	ddf_log_init(NAME, LVL_ERROR);
 	pci_fun_ops.interfaces[HW_RES_DEV_IFACE] = &pciintel_hw_res_ops;
 }
@@ -634,5 +631,5 @@
 int main(int argc, char *argv[])
 {
-	printf(NAME ": HelenOS PCI bus driver (Intel method 1).\n");
+	printf(NAME ": HelenOS pci bus driver (intel method 1).\n");
 	pciintel_init();
 	return ddf_driver_main(&pci_driver);
Index: uspace/drv/root/root.c
===================================================================
--- uspace/drv/root/root.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/drv/root/root.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -52,5 +52,4 @@
 
 #include <ddf/driver.h>
-#include <ddf/log.h>
 #include <devman.h>
 #include <ipc/devman.h>
@@ -90,11 +89,11 @@
 	int rc;
 
-	ddf_msg(LVL_DEBUG, "Adding new function for virtual devices. "
-	    "Function node is `%s' (%d %s)", name,
+	printf(NAME ": adding new function for virtual devices.\n");
+	printf(NAME ":   function node is `%s' (%d %s)\n", name,
 	    VIRTUAL_FUN_MATCH_SCORE, VIRTUAL_FUN_MATCH_ID);
 
 	fun = ddf_fun_create(dev, fun_inner, name);
 	if (fun == NULL) {
-		ddf_msg(LVL_ERROR, "Failed creating function %s", name);
+		printf(NAME ": error creating function %s\n", name);
 		return ENOMEM;
 	}
@@ -103,6 +102,5 @@
 	    VIRTUAL_FUN_MATCH_SCORE);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed adding match IDs to function %s",
-		    name);
+		printf(NAME ": error adding match IDs to function %s\n", name);
 		ddf_fun_destroy(fun);
 		return rc;
@@ -111,5 +109,5 @@
 	rc = ddf_fun_bind(fun);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed binding function %s: %s", name,
+		printf(NAME ": error binding function %s: %s\n", name,
 		    str_error(rc));
 		ddf_fun_destroy(fun);
@@ -138,5 +136,5 @@
 	platform = sysinfo_get_data("platform", &platform_size);
 	if (platform == NULL) {
-		ddf_msg(LVL_ERROR, "Failed to obtain platform name.");
+		printf(NAME ": Failed to obtain platform name.\n");
 		return ENOENT;
 	}
@@ -145,5 +143,5 @@
 	platform = realloc(platform, platform_size + 1);
 	if (platform == NULL) {
-		ddf_msg(LVL_ERROR, "Memory allocation failed.");
+		printf(NAME ": Memory allocation failed.\n");
 		return ENOMEM;
 	}
@@ -153,16 +151,16 @@
 	/* Construct match ID. */
 	if (asprintf(&match_id, PLATFORM_FUN_MATCH_ID_FMT, platform) == -1) {
-		ddf_msg(LVL_ERROR, "Memory allocation failed.");
+		printf(NAME ": Memory allocation failed.\n");
 		return ENOMEM;
 	}
 
 	/* Add function. */
-	ddf_msg(LVL_DEBUG, "Adding platform function. Function node is `%s' "
-	    " (%d %s)", PLATFORM_FUN_NAME, PLATFORM_FUN_MATCH_SCORE,
-	    match_id);
+	printf(NAME ": adding platform function\n");
+	printf(NAME ":   function node is `%s' (%d %s)\n", PLATFORM_FUN_NAME,
+	    PLATFORM_FUN_MATCH_SCORE, match_id);
 
 	fun = ddf_fun_create(dev, fun_inner, name);
 	if (fun == NULL) {
-		ddf_msg(LVL_ERROR, "Error creating function %s", name);
+		printf(NAME ": error creating function %s\n", name);
 		return ENOMEM;
 	}
@@ -170,6 +168,5 @@
 	rc = ddf_fun_add_match_id(fun, match_id, PLATFORM_FUN_MATCH_SCORE);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed adding match IDs to function %s",
-		    name);
+		printf(NAME ": error adding match IDs to function %s\n", name);
 		ddf_fun_destroy(fun);
 		return rc;
@@ -178,5 +175,5 @@
 	rc = ddf_fun_bind(fun);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed binding function %s: %s", name,
+		printf(NAME ": error binding function %s: %s\n", name,
 		    str_error(rc));
 		ddf_fun_destroy(fun);
@@ -194,5 +191,5 @@
 static int root_add_device(ddf_dev_t *dev)
 {
-	ddf_msg(LVL_DEBUG, "root_add_device, device handle=%" PRIun,
+	printf(NAME ": root_add_device, device handle=%" PRIun "\n",
 	    dev->handle);
 
@@ -207,5 +204,5 @@
 	int res = add_platform_fun(dev);
 	if (EOK != res)
-		ddf_msg(LVL_ERROR, "Failed adding child device for platform.");
+		printf(NAME ": failed to add child device for platform.\n");
 
 	return res;
@@ -215,6 +212,4 @@
 {
 	printf(NAME ": HelenOS root device driver\n");
-
-	ddf_log_init(NAME, LVL_ERROR);
 	return ddf_driver_main(&root_driver);
 }
Index: uspace/drv/rootpc/rootpc.c
===================================================================
--- uspace/drv/rootpc/rootpc.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/drv/rootpc/rootpc.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -47,5 +47,4 @@
 
 #include <ddf/driver.h>
-#include <ddf/log.h>
 #include <devman.h>
 #include <ipc/devman.h>
@@ -120,5 +119,5 @@
     rootpc_fun_t *fun)
 {
-	ddf_msg(LVL_DEBUG, "Adding new function '%s'.", name);
+	printf(NAME ": adding new function '%s'.\n", name);
 	
 	ddf_fun_t *fnode = NULL;
@@ -146,5 +145,5 @@
 	/* Register function. */
 	if (ddf_fun_bind(fnode) != EOK) {
-		ddf_msg(LVL_ERROR, "Failed binding function %s.", name);
+		printf(NAME ": error binding function %s.\n", name);
 		goto failure;
 	}
@@ -159,5 +158,5 @@
 		ddf_fun_destroy(fnode);
 	
-	ddf_msg(LVL_ERROR, "Failed adding function '%s'.", name);
+	printf(NAME ": failed to add function '%s'.\n", name);
 	
 	return false;
@@ -177,10 +176,10 @@
 static int rootpc_add_device(ddf_dev_t *dev)
 {
-	ddf_msg(LVL_DEBUG, "rootpc_add_device, device handle = %d",
+	printf(NAME ": rootpc_add_device, device handle = %d\n",
 	    (int)dev->handle);
 	
 	/* Register functions. */
 	if (!rootpc_add_functions(dev)) {
-		ddf_msg(LVL_ERROR, "Failed to add functions for PC platform.");
+		printf(NAME ": failed to add functions for PC platform.\n");
 	}
 	
@@ -190,5 +189,4 @@
 static void root_pc_init(void)
 {
-	ddf_log_init(NAME, LVL_ERROR);
 	rootpc_fun_ops.interfaces[HW_RES_DEV_IFACE] = &fun_hw_res_ops;
 }
Index: uspace/drv/rootvirt/rootvirt.c
===================================================================
--- uspace/drv/rootvirt/rootvirt.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/drv/rootvirt/rootvirt.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -40,5 +40,4 @@
 #include <str_error.h>
 #include <ddf/driver.h>
-#include <ddf/log.h>
 
 #define NAME "rootvirt"
@@ -84,10 +83,10 @@
 	int rc;
 
-	ddf_msg(LVL_DEBUG, "Registering function `%s' (match \"%s\")",
+	printf(NAME ": registering function `%s' (match \"%s\")\n",
 	    vfun->name, vfun->match_id);
 
 	fun = ddf_fun_create(vdev, fun_inner, vfun->name);
 	if (fun == NULL) {
-		ddf_msg(LVL_ERROR, "Failed creating function %s", vfun->name);
+		printf(NAME ": error creating function %s\n", vfun->name);
 		return ENOMEM;
 	}
@@ -95,5 +94,5 @@
 	rc = ddf_fun_add_match_id(fun, vfun->match_id, 10);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed adding match IDs to function %s",
+		printf(NAME ": error adding match IDs to function %s\n",
 		    vfun->name);
 		ddf_fun_destroy(fun);
@@ -103,11 +102,11 @@
 	rc = ddf_fun_bind(fun);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed binding function %s: %s",
-		    vfun->name, str_error(rc));
+		printf(NAME ": error binding function %s: %s\n", vfun->name,
+		    str_error(rc));
 		ddf_fun_destroy(fun);
 		return rc;
 	}
 
-	ddf_msg(LVL_NOTE, "Registered child device `%s'", vfun->name);
+	printf(NAME ": registered child device `%s'\n", vfun->name);
 	return EOK;
 }
@@ -125,5 +124,5 @@
 	}
 
-	ddf_msg(LVL_DEBUG, "add_device(handle=%d)", (int)dev->handle);
+	printf(NAME ": add_device(handle=%d)\n", (int)dev->handle);
 
 	/*
@@ -143,6 +142,4 @@
 {
 	printf(NAME ": HelenOS virtual devices root driver\n");
-
-	ddf_log_init(NAME, LVL_ERROR);
 	return ddf_driver_main(&rootvirt_driver);
 }
Index: uspace/drv/test1/test1.c
===================================================================
--- uspace/drv/test1/test1.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/drv/test1/test1.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -35,5 +35,4 @@
 #include <str_error.h>
 #include <ddf/driver.h>
-#include <ddf/log.h>
 
 #include "test1.h"
@@ -59,49 +58,34 @@
  */
 static int register_fun_verbose(ddf_dev_t *parent, const char *message,
-    const char *name, const char *match_id, int match_score,
-    int expected_rc)
+    const char *name, const char *match_id, int match_score)
 {
-	ddf_fun_t *fun = NULL;
+	ddf_fun_t *fun;
 	int rc;
 
-	ddf_msg(LVL_DEBUG, "Registering function `%s': %s.", name, message);
+	printf(NAME ": registering function `%s': %s.\n", name, message);
 
 	fun = ddf_fun_create(parent, fun_inner, name);
 	if (fun == NULL) {
-		ddf_msg(LVL_ERROR, "Failed creating function %s", name);
-		rc = ENOMEM;
-		goto leave;
+		printf(NAME ": error creating function %s\n", name);
+		return ENOMEM;
 	}
 
-	rc = ddf_fun_add_match_id(fun, str_dup(match_id), match_score);
+	rc = ddf_fun_add_match_id(fun, match_id, match_score);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed adding match IDs to function %s",
-		    name);
-		goto leave;
+		printf(NAME ": error adding match IDs to function %s\n", name);
+		ddf_fun_destroy(fun);
+		return rc;
 	}
 
 	rc = ddf_fun_bind(fun);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed binding function %s: %s", name,
+		printf(NAME ": error binding function %s: %s\n", name,
 		    str_error(rc));
-		goto leave;
+		ddf_fun_destroy(fun);
+		return rc;
 	}
 
-	ddf_msg(LVL_NOTE, "Registered child device `%s'", name);
-	rc = EOK;
-
-leave:
-	if (rc != expected_rc) {
-		fprintf(stderr,
-		    NAME ": Unexpected error registering function `%s'.\n" 
-		    NAME ":     Expected \"%s\" but got \"%s\".\n",
-		    name, str_error(expected_rc), str_error(rc));
-	}
-
-	if ((rc != EOK) && (fun != NULL)) {
-		ddf_fun_destroy(fun);
-	}
-
-	return rc;
+	printf(NAME ": registered child device `%s'\n", name);
+	return EOK;
 }
 
@@ -128,10 +112,10 @@
 	int rc;
 
-	ddf_msg(LVL_DEBUG, "add_device(name=\"%s\", handle=%d)",
+	printf(NAME ": add_device(name=\"%s\", handle=%d)\n",
 	    dev->name, (int) dev->handle);
 
 	fun_a = ddf_fun_create(dev, fun_exposed, "a");
 	if (fun_a == NULL) {
-		ddf_msg(LVL_ERROR, "Failed creating function 'a'.");
+		printf(NAME ": error creating function 'a'.\n");
 		return ENOMEM;
 	}
@@ -139,5 +123,5 @@
 	rc = ddf_fun_bind(fun_a);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed binding function 'a'.");
+		printf(NAME ": error binding function 'a'.\n");
 		return rc;
 	}
@@ -149,17 +133,12 @@
 		ddf_fun_add_to_class(fun_a, "virt-null");
 	} else if (str_cmp(dev->name, "test1") == 0) {
-		(void) register_fun_verbose(dev,
-		    "cloning myself ;-)", "clone",
-		    "virtual&test1", 10, EOK);
-		(void) register_fun_verbose(dev,
-		    "cloning myself twice ;-)", "clone",
-		    "virtual&test1", 10, EEXISTS);
+		(void) register_fun_verbose(dev, "cloning myself ;-)", "clone",
+		    "virtual&test1", 10);
 	} else if (str_cmp(dev->name, "clone") == 0) {
-		(void) register_fun_verbose(dev,
-		    "run by the same task", "child",
-		    "virtual&test1&child", 10, EOK);
+		(void) register_fun_verbose(dev, "run by the same task", "child",
+		    "virtual&test1&child", 10);
 	}
 
-	ddf_msg(LVL_DEBUG, "Device `%s' accepted.", dev->name);
+	printf(NAME ": device `%s' accepted.\n", dev->name);
 
 	return EOK;
@@ -169,5 +148,4 @@
 {
 	printf(NAME ": HelenOS test1 virtual device driver\n");
-	ddf_log_init(NAME, LVL_ERROR);
 	return ddf_driver_main(&test1_driver);
 }
Index: uspace/drv/test2/test2.c
===================================================================
--- uspace/drv/test2/test2.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/drv/test2/test2.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -36,5 +36,4 @@
 #include <str_error.h>
 #include <ddf/driver.h>
-#include <ddf/log.h>
 
 #define NAME "test2"
@@ -65,9 +64,9 @@
 	int rc;
 
-	ddf_msg(LVL_DEBUG, "Registering function `%s': %s.", name, message);
+	printf(NAME ": registering function `%s': %s.\n", name, message);
 
 	fun = ddf_fun_create(parent, fun_inner, name);
 	if (fun == NULL) {
-		ddf_msg(LVL_ERROR, "Failed creating function %s", name);
+		printf(NAME ": error creating function %s\n", name);
 		return ENOMEM;
 	}
@@ -75,6 +74,5 @@
 	rc = ddf_fun_add_match_id(fun, match_id, match_score);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed adding match IDs to function %s",
-		    name);
+		printf(NAME ": error adding match IDs to function %s\n", name);
 		ddf_fun_destroy(fun);
 		return rc;
@@ -83,5 +81,5 @@
 	rc = ddf_fun_bind(fun);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed binding function %s: %s", name,
+		printf(NAME ": error binding function %s: %s\n", name,
 		    str_error(rc));
 		ddf_fun_destroy(fun);
@@ -89,5 +87,5 @@
 	}
 
-	ddf_msg(LVL_NOTE, "Registered child device `%s'", name);
+	printf(NAME ": registered child device `%s'\n", name);
 	return EOK;
 }
@@ -113,5 +111,5 @@
 	fun_a = ddf_fun_create(dev, fun_exposed, "a");
 	if (fun_a == NULL) {
-		ddf_msg(LVL_ERROR, "Failed creating function 'a'.");
+		printf(NAME ": error creating function 'a'.\n");
 		return ENOMEM;
 	}
@@ -119,5 +117,5 @@
 	rc = ddf_fun_bind(fun_a);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed binding function 'a'.");
+		printf(NAME ": error binding function 'a'.\n");
 		return rc;
 	}
@@ -130,5 +128,5 @@
 static int test2_add_device(ddf_dev_t *dev)
 {
-	ddf_msg(LVL_DEBUG, "test2_add_device(name=\"%s\", handle=%d)",
+	printf(NAME ": test2_add_device(name=\"%s\", handle=%d)\n",
 	    dev->name, (int) dev->handle);
 
@@ -136,5 +134,5 @@
 		fid_t postpone = fibril_create(postponed_birth, dev);
 		if (postpone == 0) {
-			ddf_msg(LVL_ERROR, "fibril_create() failed.");
+			printf(NAME ": fibril_create() error\n");
 			return ENOMEM;
 		}
@@ -151,5 +149,4 @@
 {
 	printf(NAME ": HelenOS test2 virtual device driver\n");
-	ddf_log_init(NAME, LVL_ERROR);
 	return ddf_driver_main(&test2_driver);
 }
Index: uspace/lib/c/Makefile
===================================================================
--- uspace/lib/c/Makefile	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/Makefile	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -84,5 +84,4 @@
 	generic/io/io.c \
 	generic/io/printf.c \
-	generic/io/log.c \
 	generic/io/klog.c \
 	generic/io/snprintf.c \
Index: uspace/lib/c/arch/abs32le/_link.ld.in
===================================================================
--- uspace/lib/c/arch/abs32le/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/arch/abs32le/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -11,6 +11,6 @@
 	
 	.text : {
-		*(.text .text.*);
-		*(.rodata .rodata.*);
+		*(.text);
+		*(.rodata*);
 	} :text
 	
Index: uspace/lib/c/arch/amd64/_link.ld.in
===================================================================
--- uspace/lib/c/arch/amd64/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/arch/amd64/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -16,6 +16,6 @@
 	
 	.text : {
-		*(.text .text.*);
-		*(.rodata .rodata.*);
+		*(.text);
+		*(.rodata*);
 	} :text
 	
Index: uspace/lib/c/arch/arm32/_link.ld.in
===================================================================
--- uspace/lib/c/arch/arm32/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/arch/arm32/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -15,6 +15,6 @@
 	
 	.text : {
-		*(.text .text.*);
-		*(.rodata .rodata.*);
+		*(.text);
+		*(.rodata*);
 	} :text
 	
Index: uspace/lib/c/arch/ia32/_link.ld.in
===================================================================
--- uspace/lib/c/arch/ia32/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/arch/ia32/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -16,6 +16,6 @@
 	
 	.text : {
-		*(.text .text.*);
-		*(.rodata .rodata.*);
+		*(.text);
+		*(.rodata*);
 	} :text
 	
Index: uspace/lib/c/arch/ia64/_link.ld.in
===================================================================
--- uspace/lib/c/arch/ia64/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/arch/ia64/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -15,6 +15,6 @@
 	
 	.text : {
-		*(.text .text.*);
-		*(.rodata .rodata.*);
+		*(.text);
+		*(.rodata*);
 	} :text
 	
@@ -23,5 +23,5 @@
 	.got : {
 		_gp = .;
-		*(.got .got.*);
+		*(.got*);
 	} :data
 	
Index: uspace/lib/c/arch/mips32/_link.ld.in
===================================================================
--- uspace/lib/c/arch/mips32/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/arch/mips32/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -15,6 +15,6 @@
 	
 	.text : {
-		*(.text .text.*);
-		*(.rodata .rodata.*);
+		*(.text);
+		*(.rodata*);
 	} :text
 	
Index: uspace/lib/c/arch/ppc32/_link.ld.in
===================================================================
--- uspace/lib/c/arch/ppc32/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/arch/ppc32/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -15,6 +15,6 @@
 	
 	.text : {
-		*(.text .text.*);
-		*(.rodata .rodata.*);
+		*(.text);
+		*(.rodata*);
 	} :text
 	
Index: uspace/lib/c/arch/sparc64/_link.ld.in
===================================================================
--- uspace/lib/c/arch/sparc64/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/arch/sparc64/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -15,6 +15,6 @@
 	
 	.text : {
-		*(.text .text.*);
-		*(.rodata .rodata.*);
+		*(.text);
+		*(.rodata*);
 	} :text
 	
Index: uspace/lib/c/generic/adt/measured_strings.c
===================================================================
--- uspace/lib/c/generic/adt/measured_strings.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/generic/adt/measured_strings.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -74,5 +74,5 @@
 	new->length = length;
 	new->value = ((uint8_t *) new) + sizeof(measured_string_t);
-	/* Append terminating zero explicitly - to be safe */
+	// append terminating zero explicitly - to be safe
 	memcpy(new->value, string, new->length);
 	new->value[new->length] = '\0';
Index: uspace/lib/c/generic/devman.c
===================================================================
--- uspace/lib/c/generic/devman.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/generic/devman.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -147,4 +147,6 @@
 		ret = devman_send_match_id(phone, match_id);
 		if (ret != EOK) {
+			printf("Driver failed to send match id, error %d\n",
+			    ret);
 			return ret;
 		}
@@ -193,5 +195,5 @@
 	}
 	
-	int match_ids_rc = devman_send_match_ids(phone, match_ids);
+	devman_send_match_ids(phone, match_ids);
 	
 	async_wait_for(req, &retval);
@@ -199,9 +201,4 @@
 	async_serialize_end();
 	
-	/* Prefer the answer to DEVMAN_ADD_FUNCTION in case of errors. */
-	if ((match_ids_rc != EOK) && (retval == EOK)) {
-		retval = match_ids_rc;
-	}
-
 	if (retval == EOK)
 		fun_handle = (int) IPC_GET_ARG1(answer);
@@ -329,49 +326,4 @@
 }
 
-int devman_device_get_handle_by_class(const char *classname,
-    const char *devname, devman_handle_t *handle, unsigned int flags)
-{
-	int phone = devman_get_phone(DEVMAN_CLIENT, flags);
-
-	if (phone < 0)
-		return phone;
-
-	async_serialize_start();
-
-	ipc_call_t answer;
-	aid_t req = async_send_1(phone, DEVMAN_DEVICE_GET_HANDLE_BY_CLASS,
-	    flags, &answer);
-
-	sysarg_t retval = async_data_write_start(phone, classname,
-	    str_size(classname));
-	if (retval != EOK) {
-		async_wait_for(req, NULL);
-		async_serialize_end();
-		return retval;
-	}
-	retval = async_data_write_start(phone, devname,
-	    str_size(devname));
-	if (retval != EOK) {
-		async_wait_for(req, NULL);
-		async_serialize_end();
-		return retval;
-	}
-
-	async_wait_for(req, &retval);
-
-	async_serialize_end();
-
-	if (retval != EOK) {
-		if (handle != NULL)
-			*handle = (devman_handle_t) -1;
-		return retval;
-	}
-
-	if (handle != NULL)
-		*handle = (devman_handle_t) IPC_GET_ARG1(answer);
-
-	return retval;
-}
-
 
 /** @}
Index: uspace/lib/c/generic/net/packet.c
===================================================================
--- uspace/lib/c/generic/net/packet.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/generic/net/packet.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -190,5 +190,5 @@
 		}
 	}
-	gpm_destroy(&pm_globals.packet_map, free);
+	gpm_destroy(&pm_globals.packet_map);
 	/* leave locked */
 }
Index: uspace/lib/c/generic/net/socket_client.c
===================================================================
--- uspace/lib/c/generic/net/socket_client.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/generic/net/socket_client.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -749,5 +749,5 @@
 	dyn_fifo_destroy(&socket->received);
 	dyn_fifo_destroy(&socket->accepted);
-	sockets_exclude(socket_get_sockets(), socket->socket_id, free);
+	sockets_exclude(socket_get_sockets(), socket->socket_id);
 }
 
